您的位置:首页 > 产品设计 > UI/UE

hdu 4424 & zoj 3659 Conquer a New Region (并查集 + 贪心)

2013-08-22 13:34 429 查看

Conquer a New Region

Time Limit: 8000/4000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 657 Accepted Submission(s): 179



[align=left]Problem Description[/align]
The wheel of the history rolling forward, our king conquered a new region in a distant continent.

There are N towns (numbered from 1 to N) in this region connected by several roads. It's confirmed that there is exact one route between any two towns. Traffic is important while controlled colonies are far away from the local country. We define the capacity
C(i, j) of a road indicating it is allowed to transport at most C(i, j) goods between town i and town j if there is a road between them. And for a route between i and j, we define a value S(i, j) indicating the maximum traffic capacity between i and j which
is equal to the minimum capacity of the roads on the route.

Our king wants to select a center town to restore his war-resources in which the total traffic capacities from the center to the other N - 1 towns is maximized. Now, you, the best programmer in the kingdom, should help our king to select this center.

[align=left]Input[/align]
There are multiple test cases.

The first line of each case contains an integer N. (1 <= N <= 200,000)

The next N - 1 lines each contains three integers a, b, c indicating there is a road between town a and town b whose capacity is c. (1 <= a, b <= N, 1 <= c <= 100,000)

[align=left]Output[/align]
For each test case, output an integer indicating the total traffic capacity of the chosen center town.

[align=left]Sample Input[/align]

4
1 2 2
2 4 1
2 3 1
4
1 2 1
2 4 1
2 3 1


[align=left]Sample Output[/align]

4
3


[align=left]Source[/align]
2012 Asia ChangChun Regional Contest

[align=left]Recommend[/align]
zhuyuanchen520

题意:
给出一棵树,找出一个点,求出所有点到这个点的权值和最大,
权值为路径上所有边权的最小值。

分析:
由于要所有点到这个点的权值和最大,把边按从大到小排序并插入。每条边连接两个集合,
且每次并入的边权值都是当前已并入边中最小的。那么,只要每次并入时判断是把a并入b
得到的权值和大还是b并入a得到的权值和大就可以了。并查集维护集合的元素个数和总的
权值。

感想:
1、首先读题的时候,对最大权值
权值取路径上所有边权的最小值 理解混淆,"最大"、"最小"。。。
导致样例都没看明白啊啊啊。。。
正确理解:
那个距离其实就是容量,可以理解为路最大的承载,如果大于那个值对应的路段会倒掉。。
那么你开车从1到3,车上最多的容量为1。。

2、完了以后再hdu oj上A的代码在zoj 上wa,最后发现是输出语句中,要把"%I64d"换成“%lld".

代码:
#include<cstdio>
#include<iostream>
#include<algorithm>
#define N 200010
typedef long long ll;
using namespace std;

struct node
{
int u,v,w;
bool operator <(const node a)const
{
return w>a.w;
}
}edge
;
int cnt
,pre
;  //pre[]记录前一个节点编号
ll sum
;    //sum[i]表示i为根的边权和,cnt[i]记录i为根的树中元素个数

int find(int a)  //找根节点
{
return pre[a]=(pre[a]==a?a:find(pre[a]));
}
int main()
{
int n,i;
while(scanf("%d",&n)!=EOF)
{
for(i=1;i<=n-1;i++)
{
scanf("%d%d%d",&edge[i].u,&edge[i].v,&edge[i].w);
}
sort(edge+1,edge+n);  //从大到小排序
for(i=1;i<=n;i++)
{
cnt[i]=1;
sum[i]=0;
pre[i]=i;
}
ll ans=0;
for(i=1;i<=n-1;i++)
{
int ra=find(edge[i].u);
int rb=find(edge[i].v);
ll bisr=sum[rb]+(ll)edge[i].w*cnt[ra];
ll aisr=sum[ra]+(ll)edge[i].w*cnt[rb];
if(bisr>aisr)
{
pre[ra]=rb;
sum[rb]=bisr;
cnt[rb]+=cnt[ra];
}
else
{
pre[rb]=ra;
sum[ra]=aisr;
cnt[ra]+=cnt[rb];
}
ans=max(ans,max(aisr,bisr));
}
//printf("%I64d\n",ans);
printf("%lld\n",ans);   //zoj上需要这么写才能AC
}
return 0;
}

//bisr=把a并入b,aisr=把b并入a
//注意要用long long
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: